package cn.com.qmth.importpaper;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.commons.io.FileUtils;
import org.apache.http.HttpEntity;
import org.apache.http.ParseException;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;

public class Temp2 {

    private final static String url1 = "https://checkapi.aliyun.com/check/checkdomain?";

    private final static Pattern p = Pattern.compile("^[^a-z]*([a-z]*)(.*)$");

    private final static String param = "&command=renew&token=Y55524d856a54264296cc7773dbb65292&ua=&currency=&site=&bid=&_csrf_token=&callback=jsonp_1589269263490_77956";

    private final static int batchSize = 500000;

    private final static int start = 68427;

    private static int errTime = 0;
    
    private static int maxErrTime = 10;
    
    private static CloseableHttpClient client ;
    private static RequestConfig defaultRequestConfig = RequestConfig.custom()
            .setSocketTimeout(5000)
            .setConnectTimeout(5000)
            .setConnectionRequestTimeout(5000)
            .build();
    public static void main(String[] args) {
        client = HttpClients.custom()
                .setDefaultRequestConfig(defaultRequestConfig)
                .build();
        List<String> reList = new ArrayList<String>();
        List<String> unreList = new ArrayList<String>();
        int index = 0;
        File re = new File("d:\\ret.txt");
        File unre = new File("d:\\unret.txt");
        try {
            if (re.exists()) {
                re.delete();
            }
            if (unre.exists()) {
                unre.delete();
            }
            re.createNewFile();
            unre.createNewFile();
            
            Map<String, String> map = parse();
            for (String k : map.keySet()) {
                String dmain = k + ".com";
                char c = getRet(dmain);
                if (c == '1') {
                    reList.add(k);
                } else {
                    unreList.add(k);
                }
                index++;
                System.out.println("**************************index:" + index);
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            System.out.println("**************************count:" + reList.size());
            System.out.println("**************************un count:" + unreList.size());
            System.out.println("**************************end index:" + (index + start));
            try {
                FileUtils.writeLines(re, reList);
                FileUtils.writeLines(unre, unreList);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    private static char getRet(String dmain) {
        try {
            
            String ret = getData(client, url1 + "domain=" + dmain + param);
            char c = ret.charAt(ret.indexOf("\"avail\":") + 8);
            errTime=0;
            return c;
        } catch (Exception e) {
            errTime++;
            if (errTime <= maxErrTime) {
                client = HttpClients.custom()
                        .setDefaultRequestConfig(defaultRequestConfig)
                        .build();
                return getRet(dmain);
            } else {
                throw new RuntimeException("error:" + e.getMessage());
            }
        }

    }

    public static Map<String, String> parse() throws IOException {
        Map<String, String> map = new HashMap<String, String>();
        List<String> list = readFile();
        for (String s : list) {
//            Matcher m = p.matcher(s);
//            if (m.find()) {
//                String k = m.group(1);
//                String v = m.group(2);
//                if (!"".equals(k)) {
//                    map.put(k, v);
//                }
//            }
            if (!"".equals(s)) {
              map.put(s, s);
            }
        }
        return map;
    }

    public static List<String> readFile() throws IOException {
        int index = 0;
        List<String> list = new ArrayList<String>();
        FileInputStream fis = new FileInputStream("d:\\word.txt");
        InputStreamReader isr = new InputStreamReader(fis, "UTF-8");
        BufferedReader br = new BufferedReader(isr);
        String line = "";
        while ((line = br.readLine()) != null) {
            if (start <= index && index < start + batchSize) {
                list.add(line.toLowerCase());
            }
            index++;
        }
        br.close();
        isr.close();
        fis.close();
        return list;
    }

    public static String getData(CloseableHttpClient client, String url) {
        HttpGet get = new HttpGet(url);
        try {
            CloseableHttpResponse response = client.execute(get);
            int statusCode = response.getStatusLine().getStatusCode();
            if (statusCode == 200) {
                HttpEntity entity = response.getEntity();
                String data = EntityUtils.toString(entity, "UTF-8");
                return data;
            }
        } catch (ClientProtocolException e) {
            e.printStackTrace();
        } catch (ParseException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }
}
