package cn.com.qmth.multithread;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.log4j.Logger;

public class ComputeProducer extends Producer {
    
    private static final Logger logger = Logger.getLogger(ComputeProducer.class);
    
    private final static Pattern p = Pattern.compile("^[^a-z]*([a-z]*)(.*)$");

    @Override
    protected void produce(Map<String, Object> param) throws Exception {
        logger.info("***************************任务生产开始");
        List<Kv> list = parse();
        if (list != null && list.size() > 0) {
            for (Kv et : list) {
                // 生产数据
                offer(et);
            }
        }
        logger.info("***************************任务生产结束");
    }

    private List<Kv> parse() throws IOException {
        List<Kv> ret = new ArrayList<Kv>();
        List<String> list = readFile();
        for (String s : list) {
            Matcher m = p.matcher(s);
            if (m.find()) {
                String k = m.group(1);
                String v = m.group(2);
                if (k!=null&&v!=null) {
                    Kv o = new Kv(k, v);
                    ret.add(o);
                }
            }
        }
        return ret;
    }

    private List<String> readFile() throws IOException {
        int start=14000;
        int c=4000;
        int index=1;
        List<String> list = new ArrayList<String>();
        FileInputStream fis = new FileInputStream("d:\\cc.txt");
        InputStreamReader isr = new InputStreamReader(fis, "UTF-8");
        BufferedReader br = new BufferedReader(isr);
        String line = "";
        while ((line = br.readLine()) != null) {
            if(start<=index&&index<start+c) {
                list.add(line.toLowerCase());
            }
            index++;
        }
        
        br.close();
        isr.close();
        fis.close();
        return list;
    }
}
